Knox Docs Sign in

API reference

Test mode. Use your secret key on your server; live processing is currently disabled.

https://api.knoxapi.com

Send form-encoded requests with Authorization: Bearer sk_test_....

Complete OpenAPI specification · Integration guide

Operations and schemas are based on the pinned Stripe OpenAPI specification (MIT). Nested object definitions and enums are available in the complete specification.

GET /v1/quotes

List all quotes

Returns a list of your quotes.

Request parameters

ParameterLocationTypeDescription
customerquerystringThe ID of the customer whose quotes you're retrieving.
customer_accountquerystringThe ID of the account representing the customer whose quotes you're retrieving.
ending_beforequerystringA cursor for use in pagination. `ending_before` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting with `obj_bar`, your subsequent call can include `ending_before=obj_bar` in order to fetch the previous page of the list.
expandqueryarray of stringSpecifies which fields in the response should be expanded.
limitqueryintegerA limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 10.
starting_afterquerystringA cursor for use in pagination. `starting_after` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with `obj_foo`, your subsequent call can include `starting_after=obj_foo` in order to fetch the next page of the list.
statusquerystringThe status of the quote.
test_clockquerystringProvides a list of quotes that are associated with the specified test clock. The response will not include quotes with test clocks if this and the customer parameter is not set.

object. See the OpenAPI specification for the complete schema.

Responses

HTTP 200: Successful response.
FieldTypeDescription
data requiredarray of quote
has_more requiredbooleanTrue if this list has another page of items after this one that can be fetched.
object requiredstringString representing the object's type. Objects of the same type share the same value. Always has the value `list`.
url requiredstringThe URL where this list can be accessed.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
POST /v1/quotes

Create a quote

A quote models prices and services for a customer. Default options for header, description, footer, and expires_at can be set in the dashboard via the quote template.

Request parameters

FieldTypeDescription
application_fee_amountone of multiple schemasThe amount of the application fee (if any) that will be requested to be applied to the payment and transferred to the application owner's Stripe account. There cannot be any line items with recurring prices when using this field.
application_fee_percentone of multiple schemasA non-negative decimal between 0 and 100, with at most two decimal places. This represents the percentage of the subscription invoice total that will be transferred to the application owner's Stripe account. There must be at least 1 line item with a recurring price to use this field.
automatic_taxobjectSettings for automatic tax lookup for this quote and resulting invoices and subscriptions.
collection_methodstringEither `charge_automatically`, or `send_invoice`. When charging automatically, Stripe will attempt to pay invoices at the end of the subscription cycle or at invoice finalization using the default payment method attached to the subscription or customer. When sending an invoice, Stripe will email your customer an invoice with payment instructions and mark the subscription as `active`. Defaults to `charge_automatically`.
customerstringThe customer for which this quote belongs to. A customer is required before finalizing the quote. Once specified, it cannot be changed.
customer_accountstringThe account for which this quote belongs to. A customer or account is required before finalizing the quote. Once specified, it cannot be changed.
default_tax_ratesone of multiple schemasThe tax rates that will apply to any line item that does not have `tax_rates` set.
descriptionone of multiple schemasA description that will be displayed on the quote PDF. If no value is passed, the default description configured in your [quote template settings](https://dashboard.stripe.com/settings/billing/quote) will be used.
discountsone of multiple schemasThe discounts applied to the quote.
expandarray of stringSpecifies which fields in the response should be expanded.
expires_atintegerA future timestamp on which the quote will be canceled if in `open` or `draft` status. Measured in seconds since the Unix epoch. If no value is passed, the default expiration date configured in your [quote template settings](https://dashboard.stripe.com/settings/billing/quote) will be used.
footerone of multiple schemasA footer that will be displayed on the quote PDF. If no value is passed, the default footer configured in your [quote template settings](https://dashboard.stripe.com/settings/billing/quote) will be used.
from_quoteobjectClone an existing quote. The new quote will be created in `status=draft`. When using this parameter, you cannot specify any other parameters except for `expires_at`.
headerone of multiple schemasA header that will be displayed on the quote PDF. If no value is passed, the default header configured in your [quote template settings](https://dashboard.stripe.com/settings/billing/quote) will be used.
invoice_settingsobjectAll invoices will be billed using the specified settings.
line_itemsarray of objectA list of line items the customer is being quoted for. Each line item includes information about the product, the quantity, and the resulting cost.
metadataobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to `metadata`.
on_behalf_ofone of multiple schemasThe account on behalf of which to charge.
subscription_dataobjectWhen creating a subscription or subscription schedule, the specified configuration data will be used. There must be at least one line item with a recurring price for a subscription or subscription schedule to be created. A subscription schedule is created if `subscription_data[effective_date]` is present and in the future, otherwise a subscription is created.
test_clockstringID of the test clock to attach to the quote.
transfer_dataone of multiple schemasThe data with which to automatically create a Transfer for each of the invoices.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount_subtotal requiredintegerTotal before any discounts or taxes are applied.
amount_total requiredintegerTotal after discounts and taxes are applied.
applicationone of multiple schemasID of the Connect Application that created the quote.
application_fee_amountintegerThe amount of the application fee (if any) that will be requested to be applied to the payment and transferred to the application owner's Stripe account. Only applicable if there are no line items with recurring prices on the quote.
application_fee_percentnumberA non-negative decimal between 0 and 100, with at most two decimal places. This represents the percentage of the subscription invoice total that will be transferred to the application owner's Stripe account. Only applicable if there are line items with recurring prices on the quote.
automatic_tax requiredquotes_resource_automatic_tax
collection_method requiredstringEither `charge_automatically`, or `send_invoice`. When charging automatically, Stripe will attempt to pay invoices at the end of the subscription cycle or on finalization using the default payment method attached to the subscription or customer. When sending an invoice, Stripe will email your customer an invoice with payment instructions and mark the subscription as `active`. Defaults to `charge_automatically`.
computed requiredquotes_resource_computed
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currencystringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasThe customer who received this quote. A customer is required to finalize the quote. Once specified, you can't change it.
customer_accountstringThe account representing the customer who received this quote. A customer or account is required to finalize the quote. Once specified, you can't change it.
default_tax_ratesarray of one of multiple schemasThe tax rates applied to this quote.
descriptionstringA description that will be displayed on the quote PDF.
discounts requiredarray of one of multiple schemasThe discounts applied to this quote.
expires_at requiredintegerThe date on which the quote will be canceled if in `open` or `draft` status. Measured in seconds since the Unix epoch.
footerstringA footer that will be displayed on the quote PDF.
from_quoteone of multiple schemasDetails of the quote that was cloned. See the [cloning documentation](https://docs.stripe.com/quotes/clone) for more details.
headerstringA header that will be displayed on the quote PDF.
id requiredstringUnique identifier for the object.
invoiceone of multiple schemasThe invoice that was created from this quote.
invoice_settings requiredinvoice_setting_quote_setting
line_itemsobjectA list of items the customer is being quoted for.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
numberstringA unique number that identifies this particular quote. This number is assigned once the quote is [finalized](https://docs.stripe.com/quotes/overview#finalize).
object requiredstringString representing the object's type. Objects of the same type share the same value.
on_behalf_ofone of multiple schemasThe account on behalf of which to charge. See the [Connect documentation](https://support.stripe.com/questions/sending-invoices-on-behalf-of-connected-accounts) for details.
status requiredstringThe status of the quote.
status_transitions requiredquotes_resource_status_transitions
subscriptionone of multiple schemasThe subscription that was created or updated from this quote.
subscription_data requiredquotes_resource_subscription_data_subscription_data
subscription_scheduleone of multiple schemasThe subscription schedule that was created or updated from this quote.
test_clockone of multiple schemasID of the test clock this quote belongs to.
total_details requiredquotes_resource_total_details
transfer_dataone of multiple schemasThe account (if any) the payments will be attributed to for tax reporting, and where funds from each payment will be transferred to for each of the invoices.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
GET /v1/quotes/{quote}

Retrieve a quote

Retrieves the quote with the given ID.

Request parameters

ParameterLocationTypeDescription
expandqueryarray of stringSpecifies which fields in the response should be expanded.
quotepathstring

object. See the OpenAPI specification for the complete schema.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount_subtotal requiredintegerTotal before any discounts or taxes are applied.
amount_total requiredintegerTotal after discounts and taxes are applied.
applicationone of multiple schemasID of the Connect Application that created the quote.
application_fee_amountintegerThe amount of the application fee (if any) that will be requested to be applied to the payment and transferred to the application owner's Stripe account. Only applicable if there are no line items with recurring prices on the quote.
application_fee_percentnumberA non-negative decimal between 0 and 100, with at most two decimal places. This represents the percentage of the subscription invoice total that will be transferred to the application owner's Stripe account. Only applicable if there are line items with recurring prices on the quote.
automatic_tax requiredquotes_resource_automatic_tax
collection_method requiredstringEither `charge_automatically`, or `send_invoice`. When charging automatically, Stripe will attempt to pay invoices at the end of the subscription cycle or on finalization using the default payment method attached to the subscription or customer. When sending an invoice, Stripe will email your customer an invoice with payment instructions and mark the subscription as `active`. Defaults to `charge_automatically`.
computed requiredquotes_resource_computed
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currencystringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasThe customer who received this quote. A customer is required to finalize the quote. Once specified, you can't change it.
customer_accountstringThe account representing the customer who received this quote. A customer or account is required to finalize the quote. Once specified, you can't change it.
default_tax_ratesarray of one of multiple schemasThe tax rates applied to this quote.
descriptionstringA description that will be displayed on the quote PDF.
discounts requiredarray of one of multiple schemasThe discounts applied to this quote.
expires_at requiredintegerThe date on which the quote will be canceled if in `open` or `draft` status. Measured in seconds since the Unix epoch.
footerstringA footer that will be displayed on the quote PDF.
from_quoteone of multiple schemasDetails of the quote that was cloned. See the [cloning documentation](https://docs.stripe.com/quotes/clone) for more details.
headerstringA header that will be displayed on the quote PDF.
id requiredstringUnique identifier for the object.
invoiceone of multiple schemasThe invoice that was created from this quote.
invoice_settings requiredinvoice_setting_quote_setting
line_itemsobjectA list of items the customer is being quoted for.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
numberstringA unique number that identifies this particular quote. This number is assigned once the quote is [finalized](https://docs.stripe.com/quotes/overview#finalize).
object requiredstringString representing the object's type. Objects of the same type share the same value.
on_behalf_ofone of multiple schemasThe account on behalf of which to charge. See the [Connect documentation](https://support.stripe.com/questions/sending-invoices-on-behalf-of-connected-accounts) for details.
status requiredstringThe status of the quote.
status_transitions requiredquotes_resource_status_transitions
subscriptionone of multiple schemasThe subscription that was created or updated from this quote.
subscription_data requiredquotes_resource_subscription_data_subscription_data
subscription_scheduleone of multiple schemasThe subscription schedule that was created or updated from this quote.
test_clockone of multiple schemasID of the test clock this quote belongs to.
total_details requiredquotes_resource_total_details
transfer_dataone of multiple schemasThe account (if any) the payments will be attributed to for tax reporting, and where funds from each payment will be transferred to for each of the invoices.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
POST /v1/quotes/{quote}

Update a quote

A quote models prices and services for a customer.

Request parameters

ParameterLocationTypeDescription
quotepathstring
FieldTypeDescription
application_fee_amountone of multiple schemasThe amount of the application fee (if any) that will be requested to be applied to the payment and transferred to the application owner's Stripe account. There cannot be any line items with recurring prices when using this field.
application_fee_percentone of multiple schemasA non-negative decimal between 0 and 100, with at most two decimal places. This represents the percentage of the subscription invoice total that will be transferred to the application owner's Stripe account. There must be at least 1 line item with a recurring price to use this field.
automatic_taxobjectSettings for automatic tax lookup for this quote and resulting invoices and subscriptions.
collection_methodstringEither `charge_automatically`, or `send_invoice`. When charging automatically, Stripe will attempt to pay invoices at the end of the subscription cycle or at invoice finalization using the default payment method attached to the subscription or customer. When sending an invoice, Stripe will email your customer an invoice with payment instructions and mark the subscription as `active`. Defaults to `charge_automatically`.
customerstringThe customer for which this quote belongs to. A customer is required before finalizing the quote. Once specified, it cannot be changed.
customer_accountstringThe account for which this quote belongs to. A customer or account is required before finalizing the quote. Once specified, it cannot be changed.
default_tax_ratesone of multiple schemasThe tax rates that will apply to any line item that does not have `tax_rates` set.
descriptionone of multiple schemasA description that will be displayed on the quote PDF.
discountsone of multiple schemasThe discounts applied to the quote.
expandarray of stringSpecifies which fields in the response should be expanded.
expires_atintegerA future timestamp on which the quote will be canceled if in `open` or `draft` status. Measured in seconds since the Unix epoch.
footerone of multiple schemasA footer that will be displayed on the quote PDF.
headerone of multiple schemasA header that will be displayed on the quote PDF.
invoice_settingsobjectAll invoices will be billed using the specified settings.
line_itemsarray of objectA list of line items the customer is being quoted for. Each line item includes information about the product, the quantity, and the resulting cost.
metadataobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to `metadata`.
on_behalf_ofone of multiple schemasThe account on behalf of which to charge.
subscription_dataobjectWhen creating a subscription or subscription schedule, the specified configuration data will be used. There must be at least one line item with a recurring price for a subscription or subscription schedule to be created. A subscription schedule is created if `subscription_data[effective_date]` is present and in the future, otherwise a subscription is created.
transfer_dataone of multiple schemasThe data with which to automatically create a Transfer for each of the invoices.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount_subtotal requiredintegerTotal before any discounts or taxes are applied.
amount_total requiredintegerTotal after discounts and taxes are applied.
applicationone of multiple schemasID of the Connect Application that created the quote.
application_fee_amountintegerThe amount of the application fee (if any) that will be requested to be applied to the payment and transferred to the application owner's Stripe account. Only applicable if there are no line items with recurring prices on the quote.
application_fee_percentnumberA non-negative decimal between 0 and 100, with at most two decimal places. This represents the percentage of the subscription invoice total that will be transferred to the application owner's Stripe account. Only applicable if there are line items with recurring prices on the quote.
automatic_tax requiredquotes_resource_automatic_tax
collection_method requiredstringEither `charge_automatically`, or `send_invoice`. When charging automatically, Stripe will attempt to pay invoices at the end of the subscription cycle or on finalization using the default payment method attached to the subscription or customer. When sending an invoice, Stripe will email your customer an invoice with payment instructions and mark the subscription as `active`. Defaults to `charge_automatically`.
computed requiredquotes_resource_computed
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currencystringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasThe customer who received this quote. A customer is required to finalize the quote. Once specified, you can't change it.
customer_accountstringThe account representing the customer who received this quote. A customer or account is required to finalize the quote. Once specified, you can't change it.
default_tax_ratesarray of one of multiple schemasThe tax rates applied to this quote.
descriptionstringA description that will be displayed on the quote PDF.
discounts requiredarray of one of multiple schemasThe discounts applied to this quote.
expires_at requiredintegerThe date on which the quote will be canceled if in `open` or `draft` status. Measured in seconds since the Unix epoch.
footerstringA footer that will be displayed on the quote PDF.
from_quoteone of multiple schemasDetails of the quote that was cloned. See the [cloning documentation](https://docs.stripe.com/quotes/clone) for more details.
headerstringA header that will be displayed on the quote PDF.
id requiredstringUnique identifier for the object.
invoiceone of multiple schemasThe invoice that was created from this quote.
invoice_settings requiredinvoice_setting_quote_setting
line_itemsobjectA list of items the customer is being quoted for.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
numberstringA unique number that identifies this particular quote. This number is assigned once the quote is [finalized](https://docs.stripe.com/quotes/overview#finalize).
object requiredstringString representing the object's type. Objects of the same type share the same value.
on_behalf_ofone of multiple schemasThe account on behalf of which to charge. See the [Connect documentation](https://support.stripe.com/questions/sending-invoices-on-behalf-of-connected-accounts) for details.
status requiredstringThe status of the quote.
status_transitions requiredquotes_resource_status_transitions
subscriptionone of multiple schemasThe subscription that was created or updated from this quote.
subscription_data requiredquotes_resource_subscription_data_subscription_data
subscription_scheduleone of multiple schemasThe subscription schedule that was created or updated from this quote.
test_clockone of multiple schemasID of the test clock this quote belongs to.
total_details requiredquotes_resource_total_details
transfer_dataone of multiple schemasThe account (if any) the payments will be attributed to for tax reporting, and where funds from each payment will be transferred to for each of the invoices.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
POST /v1/quotes/{quote}/accept

Accept a quote

Accepts the specified quote.

Request parameters

ParameterLocationTypeDescription
quotepathstring
FieldTypeDescription
expandarray of stringSpecifies which fields in the response should be expanded.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount_subtotal requiredintegerTotal before any discounts or taxes are applied.
amount_total requiredintegerTotal after discounts and taxes are applied.
applicationone of multiple schemasID of the Connect Application that created the quote.
application_fee_amountintegerThe amount of the application fee (if any) that will be requested to be applied to the payment and transferred to the application owner's Stripe account. Only applicable if there are no line items with recurring prices on the quote.
application_fee_percentnumberA non-negative decimal between 0 and 100, with at most two decimal places. This represents the percentage of the subscription invoice total that will be transferred to the application owner's Stripe account. Only applicable if there are line items with recurring prices on the quote.
automatic_tax requiredquotes_resource_automatic_tax
collection_method requiredstringEither `charge_automatically`, or `send_invoice`. When charging automatically, Stripe will attempt to pay invoices at the end of the subscription cycle or on finalization using the default payment method attached to the subscription or customer. When sending an invoice, Stripe will email your customer an invoice with payment instructions and mark the subscription as `active`. Defaults to `charge_automatically`.
computed requiredquotes_resource_computed
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currencystringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasThe customer who received this quote. A customer is required to finalize the quote. Once specified, you can't change it.
customer_accountstringThe account representing the customer who received this quote. A customer or account is required to finalize the quote. Once specified, you can't change it.
default_tax_ratesarray of one of multiple schemasThe tax rates applied to this quote.
descriptionstringA description that will be displayed on the quote PDF.
discounts requiredarray of one of multiple schemasThe discounts applied to this quote.
expires_at requiredintegerThe date on which the quote will be canceled if in `open` or `draft` status. Measured in seconds since the Unix epoch.
footerstringA footer that will be displayed on the quote PDF.
from_quoteone of multiple schemasDetails of the quote that was cloned. See the [cloning documentation](https://docs.stripe.com/quotes/clone) for more details.
headerstringA header that will be displayed on the quote PDF.
id requiredstringUnique identifier for the object.
invoiceone of multiple schemasThe invoice that was created from this quote.
invoice_settings requiredinvoice_setting_quote_setting
line_itemsobjectA list of items the customer is being quoted for.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
numberstringA unique number that identifies this particular quote. This number is assigned once the quote is [finalized](https://docs.stripe.com/quotes/overview#finalize).
object requiredstringString representing the object's type. Objects of the same type share the same value.
on_behalf_ofone of multiple schemasThe account on behalf of which to charge. See the [Connect documentation](https://support.stripe.com/questions/sending-invoices-on-behalf-of-connected-accounts) for details.
status requiredstringThe status of the quote.
status_transitions requiredquotes_resource_status_transitions
subscriptionone of multiple schemasThe subscription that was created or updated from this quote.
subscription_data requiredquotes_resource_subscription_data_subscription_data
subscription_scheduleone of multiple schemasThe subscription schedule that was created or updated from this quote.
test_clockone of multiple schemasID of the test clock this quote belongs to.
total_details requiredquotes_resource_total_details
transfer_dataone of multiple schemasThe account (if any) the payments will be attributed to for tax reporting, and where funds from each payment will be transferred to for each of the invoices.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
POST /v1/quotes/{quote}/cancel

Cancel a quote

Cancels the quote.

Request parameters

ParameterLocationTypeDescription
quotepathstring
FieldTypeDescription
expandarray of stringSpecifies which fields in the response should be expanded.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount_subtotal requiredintegerTotal before any discounts or taxes are applied.
amount_total requiredintegerTotal after discounts and taxes are applied.
applicationone of multiple schemasID of the Connect Application that created the quote.
application_fee_amountintegerThe amount of the application fee (if any) that will be requested to be applied to the payment and transferred to the application owner's Stripe account. Only applicable if there are no line items with recurring prices on the quote.
application_fee_percentnumberA non-negative decimal between 0 and 100, with at most two decimal places. This represents the percentage of the subscription invoice total that will be transferred to the application owner's Stripe account. Only applicable if there are line items with recurring prices on the quote.
automatic_tax requiredquotes_resource_automatic_tax
collection_method requiredstringEither `charge_automatically`, or `send_invoice`. When charging automatically, Stripe will attempt to pay invoices at the end of the subscription cycle or on finalization using the default payment method attached to the subscription or customer. When sending an invoice, Stripe will email your customer an invoice with payment instructions and mark the subscription as `active`. Defaults to `charge_automatically`.
computed requiredquotes_resource_computed
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currencystringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasThe customer who received this quote. A customer is required to finalize the quote. Once specified, you can't change it.
customer_accountstringThe account representing the customer who received this quote. A customer or account is required to finalize the quote. Once specified, you can't change it.
default_tax_ratesarray of one of multiple schemasThe tax rates applied to this quote.
descriptionstringA description that will be displayed on the quote PDF.
discounts requiredarray of one of multiple schemasThe discounts applied to this quote.
expires_at requiredintegerThe date on which the quote will be canceled if in `open` or `draft` status. Measured in seconds since the Unix epoch.
footerstringA footer that will be displayed on the quote PDF.
from_quoteone of multiple schemasDetails of the quote that was cloned. See the [cloning documentation](https://docs.stripe.com/quotes/clone) for more details.
headerstringA header that will be displayed on the quote PDF.
id requiredstringUnique identifier for the object.
invoiceone of multiple schemasThe invoice that was created from this quote.
invoice_settings requiredinvoice_setting_quote_setting
line_itemsobjectA list of items the customer is being quoted for.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
numberstringA unique number that identifies this particular quote. This number is assigned once the quote is [finalized](https://docs.stripe.com/quotes/overview#finalize).
object requiredstringString representing the object's type. Objects of the same type share the same value.
on_behalf_ofone of multiple schemasThe account on behalf of which to charge. See the [Connect documentation](https://support.stripe.com/questions/sending-invoices-on-behalf-of-connected-accounts) for details.
status requiredstringThe status of the quote.
status_transitions requiredquotes_resource_status_transitions
subscriptionone of multiple schemasThe subscription that was created or updated from this quote.
subscription_data requiredquotes_resource_subscription_data_subscription_data
subscription_scheduleone of multiple schemasThe subscription schedule that was created or updated from this quote.
test_clockone of multiple schemasID of the test clock this quote belongs to.
total_details requiredquotes_resource_total_details
transfer_dataone of multiple schemasThe account (if any) the payments will be attributed to for tax reporting, and where funds from each payment will be transferred to for each of the invoices.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
GET /v1/quotes/{quote}/computed_upfront_line_items

Retrieve a quote's upfront line items

When retrieving a quote, there is an includable computed.upfront.line_items property containing the first handful of those items. There is also a URL where you can retrieve the full (paginated) list of upfront line items.

Request parameters

ParameterLocationTypeDescription
ending_beforequerystringA cursor for use in pagination. `ending_before` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting with `obj_bar`, your subsequent call can include `ending_before=obj_bar` in order to fetch the previous page of the list.
expandqueryarray of stringSpecifies which fields in the response should be expanded.
limitqueryintegerA limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 10.
quotepathstring
starting_afterquerystringA cursor for use in pagination. `starting_after` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with `obj_foo`, your subsequent call can include `starting_after=obj_foo` in order to fetch the next page of the list.

object. See the OpenAPI specification for the complete schema.

Responses

HTTP 200: Successful response.
FieldTypeDescription
data requiredarray of itemDetails about each object.
has_more requiredbooleanTrue if this list has another page of items after this one that can be fetched.
object requiredstringString representing the object's type. Objects of the same type share the same value. Always has the value `list`.
url requiredstringThe URL where this list can be accessed.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
POST /v1/quotes/{quote}/finalize

Finalize a quote

Finalizes the quote.

Request parameters

ParameterLocationTypeDescription
quotepathstring
FieldTypeDescription
expandarray of stringSpecifies which fields in the response should be expanded.
expires_atintegerA future timestamp on which the quote will be canceled if in `open` or `draft` status. Measured in seconds since the Unix epoch.

Responses

HTTP 200: Successful response.
FieldTypeDescription
amount_subtotal requiredintegerTotal before any discounts or taxes are applied.
amount_total requiredintegerTotal after discounts and taxes are applied.
applicationone of multiple schemasID of the Connect Application that created the quote.
application_fee_amountintegerThe amount of the application fee (if any) that will be requested to be applied to the payment and transferred to the application owner's Stripe account. Only applicable if there are no line items with recurring prices on the quote.
application_fee_percentnumberA non-negative decimal between 0 and 100, with at most two decimal places. This represents the percentage of the subscription invoice total that will be transferred to the application owner's Stripe account. Only applicable if there are line items with recurring prices on the quote.
automatic_tax requiredquotes_resource_automatic_tax
collection_method requiredstringEither `charge_automatically`, or `send_invoice`. When charging automatically, Stripe will attempt to pay invoices at the end of the subscription cycle or on finalization using the default payment method attached to the subscription or customer. When sending an invoice, Stripe will email your customer an invoice with payment instructions and mark the subscription as `active`. Defaults to `charge_automatically`.
computed requiredquotes_resource_computed
created requiredintegerTime at which the object was created. Measured in seconds since the Unix epoch.
currencystringThree-letter [ISO currency code](https://www.iso.org/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https://stripe.com/docs/currencies).
customerone of multiple schemasThe customer who received this quote. A customer is required to finalize the quote. Once specified, you can't change it.
customer_accountstringThe account representing the customer who received this quote. A customer or account is required to finalize the quote. Once specified, you can't change it.
default_tax_ratesarray of one of multiple schemasThe tax rates applied to this quote.
descriptionstringA description that will be displayed on the quote PDF.
discounts requiredarray of one of multiple schemasThe discounts applied to this quote.
expires_at requiredintegerThe date on which the quote will be canceled if in `open` or `draft` status. Measured in seconds since the Unix epoch.
footerstringA footer that will be displayed on the quote PDF.
from_quoteone of multiple schemasDetails of the quote that was cloned. See the [cloning documentation](https://docs.stripe.com/quotes/clone) for more details.
headerstringA header that will be displayed on the quote PDF.
id requiredstringUnique identifier for the object.
invoiceone of multiple schemasThe invoice that was created from this quote.
invoice_settings requiredinvoice_setting_quote_setting
line_itemsobjectA list of items the customer is being quoted for.
livemode requiredbooleanIf the object exists in live mode, the value is `true`. If the object exists in test mode, the value is `false`.
metadata requiredobjectSet of [key-value pairs](https://docs.stripe.com/api/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
numberstringA unique number that identifies this particular quote. This number is assigned once the quote is [finalized](https://docs.stripe.com/quotes/overview#finalize).
object requiredstringString representing the object's type. Objects of the same type share the same value.
on_behalf_ofone of multiple schemasThe account on behalf of which to charge. See the [Connect documentation](https://support.stripe.com/questions/sending-invoices-on-behalf-of-connected-accounts) for details.
status requiredstringThe status of the quote.
status_transitions requiredquotes_resource_status_transitions
subscriptionone of multiple schemasThe subscription that was created or updated from this quote.
subscription_data requiredquotes_resource_subscription_data_subscription_data
subscription_scheduleone of multiple schemasThe subscription schedule that was created or updated from this quote.
test_clockone of multiple schemasID of the test clock this quote belongs to.
total_details requiredquotes_resource_total_details
transfer_dataone of multiple schemasThe account (if any) the payments will be attributed to for tax reporting, and where funds from each payment will be transferred to for each of the invoices.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
GET /v1/quotes/{quote}/line_items

Retrieve a quote's line items

When retrieving a quote, there is an includable line_items property containing the first handful of those items. There is also a URL where you can retrieve the full (paginated) list of line items.

Request parameters

ParameterLocationTypeDescription
ending_beforequerystringA cursor for use in pagination. `ending_before` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting with `obj_bar`, your subsequent call can include `ending_before=obj_bar` in order to fetch the previous page of the list.
expandqueryarray of stringSpecifies which fields in the response should be expanded.
limitqueryintegerA limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 10.
quotepathstring
starting_afterquerystringA cursor for use in pagination. `starting_after` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with `obj_foo`, your subsequent call can include `starting_after=obj_foo` in order to fetch the next page of the list.

object. See the OpenAPI specification for the complete schema.

Responses

HTTP 200: Successful response.
FieldTypeDescription
data requiredarray of itemDetails about each object.
has_more requiredbooleanTrue if this list has another page of items after this one that can be fetched.
object requiredstringString representing the object's type. Objects of the same type share the same value. Always has the value `list`.
url requiredstringThe URL where this list can be accessed.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors
GET /v1/quotes/{quote}/pdf

Download quote PDF

Download the PDF for a finalized quote. Explanation for special handling can be found here

Request parameters

ParameterLocationTypeDescription
expandqueryarray of stringSpecifies which fields in the response should be expanded.
quotepathstring

object. See the OpenAPI specification for the complete schema.

Responses

HTTP 200: Successful response.
HTTP default: Error response.
FieldTypeDescription
error requiredapi_errors